
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL SERVER实用经验技巧集 / iVAN</title>

    <meta name="description" content="SQL SERVER实用经验技巧集 server|技巧 Sql Server实用操作小技巧集合包括安装时提示有挂起的操作.收缩数据库.压缩数据库.转移数据库给新用户以已存在用户权限.检查备份集.修复数据库等  (一)挂起操作在安装Sql或sp补丁的时候系统提示之前有挂起的安装操作,要求重启,这里往往重启无用,解决办法:到HKEY_LOCAL_MACHINE YSTEM\CurrentControlSet\Control ession Manager删除PendingFileRenameOperations (二)收缩数据库--重建">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">SQL SERVER实用经验技巧集</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>server|技巧</p>
<p>Sql Server实用操作小技巧集合<br />包括安装时提示有挂起的操作、收缩数据库、压缩数据库、转移数据库给新用户以已存在用户权限、检查备份集、修复数据库等 <br /> （一）挂起操作<br />在安装Sql或sp补丁的时候系统提示之前有挂起的安装操作，要求重启，这里往往重启无用，解决办法：<br />到HKEY_LOCAL_MACHINE YSTEM\CurrentControlSet\Control ession Manager<br />删除PendingFileRenameOperations</p>
<p>（二）收缩数据库<br />--重建索引<br />DBCC REINDEX<br />DBCC INDEXDEFRAG<br />--收缩数据和日志<br />DBCC SHRINKDB<br />DBCC SHRINKFILE</p>
<p>（三）压缩数据库<br />dbcc shrinkdatabase(dbname)</p>
<p>（四）转移数据库给新用户以已存在用户权限<br />exec sp_change_users_login 'update_one','newname','oldname'<br />go</p>
<p>（五）检查备份集<br />RESTORE VERIFYONLY from disk='E:\dvbbs.bak'</p>
<p>（六）修复数据库<br />ALTER DATABASE [dvbbs] SET SINGLE_USER<br />GO<br />DBCC CHECKDB('dvbbs',repair_allow_data_loss) WITH TABLOCK<br />GO<br />ALTER DATABASE [dvbbs] SET MULTI_USER<br />GO</p>
<p>--CHECKDB 有3个参数:<br />--REPAIR_ALLOW_DATA_LOSS <br />--  执行由 REPAIR_REBUILD 完成的所有修复，包括对行和页进行分配和取消分配以改正分配错误、结构行或页的错误，以及删除已损坏的文本对象。这些修复可能会导致一些数据丢失。修复操作可以在用户事务下完成以允许用户回滚所做的更改。如果回滚修复，则数据库仍会含有错误，应该从备份进行恢复。如果由于所提供修复等级的缘故遗漏某个错误的修复，则将遗漏任何取决于该修复的修复。修复完成后，备份数据库。 <br />--REPAIR_FAST 进行小的、不耗时的修复操作，如修复非聚集索引中的附加键。这些修复可以很快完成，并且不会有丢失数据的危险。 <br />--REPAIR_REBUILD 执行由 REPAIR_FAST 完成的所有修复，包括需要较长时间的修复（如重建索引）。执行这些修复时不会有丢失数据的危险。</p>
<p>--DBCC CHECKDB('dvbbs') with NO_INFOMSGS,PHYSICAL_ONLY</p>
<p>SQL SERVER日志清除的两种方法<br />在使用过程中大家经常碰到数据库日志非常大的情况，在这里介绍了两种处理方法……</p>
<p>方法一</p>
<p>一般情况下，SQL数据库的收缩并不能很大程度上减小数据库大小，其主要作用是收缩日志大小，应当定期进行此操作以免数据库日志过大<br />1、设置数据库模式为简单模式：打开SQL企业管理器，在控制台根目录中依次点开Microsoft SQL Server--&gt;SQL Server组--&gt;双击打开你的服务器--&gt;双击打开数据库目录--&gt;选择你的数据库名称（如论坛数据库Forum）--&gt;然后点击右键选择属性--&gt;选择选项--&gt;在故障还原的模式中选择“简单”，然后按确定保存<br />2、在当前数据库上点右键，看所有任务中的收缩数据库，一般里面的默认设置不用调整，直接点确定<br />3、收缩数据库完成后，建议将您的数据库属性重新设置为标准模式，操作方法同第一点，因为日志在一些异常情况下往往是恢复数据库的重要依据</p>
<p>方法二</p>
<p>SET NOCOUNT ON<br />DECLARE @LogicalFileName sysname,<br />        @MaxMinutes INT,<br />        @NewSize INT</p>
<p>USE     tablename             -- 要操作的数据库名<br />SELECT  @LogicalFileName = 'tablename_log',  -- 日志文件名<br />@MaxMinutes = 10,               -- Limit on time allowed to wrap log.<br />        @NewSize = 1                  -- 你想设定的日志文件的大小(M)</p>
<p>-- Setup / initialize<br />DECLARE @OriginalSize int<br />SELECT @OriginalSize = size <br />  FROM sysfiles<br />  WHERE name = @LogicalFileName<br />SELECT 'Original Size of ' + db_name() + ' LOG is ' + <br />        CONVERT(VARCHAR(30),@OriginalSize) + ' 8K pages or ' + <br />        CONVERT(VARCHAR(30),(@OriginalSize*8/1024)) + 'MB'<br />  FROM sysfiles<br />  WHERE name = @LogicalFileName<br />CREATE TABLE DummyTrans<br />  (DummyColumn char (8000) not null)</p>
<p>DECLARE @Counter   INT,<br />        @StartTime DATETIME,<br />        @TruncLog  VARCHAR(255)<br />SELECT  @StartTime = GETDATE(),<br />        @TruncLog = 'BACKUP LOG ' + db_name() + ' WITH TRUNCATE_ONLY'</p>
<p>DBCC SHRINKFILE (@LogicalFileName, @NewSize)<br />EXEC (@TruncLog)<br />-- Wrap the log if necessary.<br />WHILE     @MaxMinutes &gt; DATEDIFF (mi, @StartTime, GETDATE()) -- time has not expired<br />      AND @OriginalSize = (SELECT size FROM sysfiles WHERE name = @LogicalFileName)  <br />      AND (@OriginalSize * 8 /1024) &gt; @NewSize  <br />  BEGIN -- Outer loop.<br />    SELECT @Counter = 0<br />    WHILE  ((@Counter &lt; @OriginalSize / 16) AND (@Counter &lt; 50000))<br />      BEGIN -- update<br />        INSERT DummyTrans VALUES ('Fill Log')  <br />        DELETE DummyTrans<br />        SELECT @Counter = @Counter + 1<br />      END   <br />    EXEC (@TruncLog)  <br />  END   <br />SELECT 'Final Size of ' + db_name() + ' LOG is ' +<br />        CONVERT(VARCHAR(30),size) + ' 8K pages or ' + <br />        CONVERT(VARCHAR(30),(size*8/1024)) + 'MB'<br />  FROM sysfiles <br />  WHERE name = @LogicalFileName<br />DROP TABLE DummyTrans<br />SET NOCOUNT OFF</p>
<p>删除数据库中重复数据的几个方法<br />数据库的使用过程中由于程序方面的问题有时候会碰到重复数据，重复数据导致了数据库部分设置不能正确设置……</p>
<p>方法一</p>
<p>declare @max integer,@id integer<br />declare cur_rows cursor local for select 主字段,count(*) from 表名 group by 主字段 having count(*) &gt; 1<br />open cur_rows<br />fetch cur_rows into @id,@max<br />while @@fetch_status=0<br />begin<br />select @max = @max -1<br />set rowcount @max<br />delete from 表名 where 主字段 = @id<br />fetch cur_rows into @id,@max<br />end<br />close cur_rows<br />set rowcount 0</p>
<p>方法二</p>
<p>有两个意义上的重复记录，一是完全重复的记录，也即所有字段均重复的记录，二是部分关键字段重复的记录，比如Name字段重复，而其他字段不一定重复或都重复可以忽略。<br />1、对于第一种重复，比较容易解决，使用<br />    select distinct * from tableName<br />就可以得到无重复记录的结果集。<br />如果该表需要删除重复的记录（重复记录保留1条），可以按以下方法删除<br />    select distinct * into #Tmp from tableName<br />    drop table tableName<br />    select * into tableName from #Tmp<br />    drop table #Tmp<br />发生这种重复的原因是表设计不周产生的，增加唯一索引列即可解决。</p>
<p>2、这类重复问题通常要求保留重复记录中的第一条记录，操作方法如下<br />    假设有重复的字段为Name,Address，要求得到这两个字段唯一的结果集<br />    select identity(int,1,1) as autoID, * into #Tmp from tableName<br />    select min(autoID) as autoID into #Tmp2 from #Tmp group by Name,autoID<br />    select * from #Tmp where autoID in(select autoID from #tmp2)<br />    最后一个select即得到了Name，Address不重复的结果集（但多了一个autoID字段，实际写时可以写在select子句中省去此列）</p>
<p>更改数据库中表的所属用户的两个方法<br />大家可能会经常碰到一个数据库备份还原到另外一台机器结果导致所有的表都不能打开了，原因是建表的时候采用了当时的数据库用户……</p>
<p>--更改某个表<br />exec sp_changeobjectowner 'tablename','dbo'</p>
<p>--存储更改全部表<br />CREATE PROCEDURE dbo.User_ChangeObjectOwnerBatch<br /> @OldOwner as NVARCHAR(128),<br /> @NewOwner as NVARCHAR(128)<br />AS</p>
<p>DECLARE @Name   as NVARCHAR(128)<br />DECLARE @Owner  as NVARCHAR(128)<br />DECLARE @OwnerName  as NVARCHAR(128)</p>
<p>DECLARE curObject CURSOR FOR <br /> select 'Name'   = name,<br />  'Owner'   = user_name(uid)<br /> from sysobjects<br /> where user_name(uid)=@OldOwner<br /> order by name</p>
<p>OPEN  curObject<br />FETCH NEXT FROM curObject INTO @Name, @Owner<br />WHILE(@@FETCH_STATUS=0)<br />BEGIN     <br /> if @Owner=@OldOwner <br /> begin<br />  set @OwnerName = @OldOwner + '.' + rtrim(@Name)<br />  exec sp_changeobjectowner @OwnerName, @NewOwner<br /> end<br />-- select @name,@NewOwner,@OldOwner</p>
<p> FETCH NEXT FROM curObject INTO @Name, @Owner<br />END</p>
<p>close curObject<br />deallocate curObject</p>
<p>GO</p>
<p>SQL SERVER中直接循环写入数据<br />没什么好说的了，大家自己看，有时候有点用处</p>
<p>declare @i int<br />set @i=1<br />while @i&lt;30<br />begin<br />   insert into test (userid) values(@i)<br />   set @i=@i+1<br />end</p>
<p>无数据库日志文件恢复数据库方法两则<br />数据库日志文件的误删或别的原因引起数据库日志的损坏</p>
<p>方法一</p>
<p>1.新建一个同名的数据库</p>
<p>2.再停掉sql server(注意不要分离数据库)</p>
<p>3.用原数据库的数据文件覆盖掉这个新建的数据库</p>
<p>4.再重启sql server</p>
<p>5.此时打开企业管理器时会出现置疑，先不管，执行下面的语句（注意修改其中的数据库名)</p>
<p>6.完成后一般就可以访问数据库中的数据了,这时,数据库本身一般还要问题,解决办法是,利用<br />数据库的脚本创建一个新的数据库,并将数据导进去就行了.</p>
<p>USE MASTER<br />GO</p>
<p>SP_CONFIGURE 'ALLOW UPDATES',1 RECONFIGURE WITH OVERRIDE<br />GO</p>
<p>UPDATE SYSDATABASES SET STATUS =32768 WHERE NAME='置疑的数据库名'<br />Go</p>
<p>sp_dboption '置疑的数据库名', 'single user', 'true'<br />Go</p>
<p>DBCC CHECKDB('置疑的数据库名') <br />Go</p>
<p>update sysdatabases set status =28 where name='置疑的数据库名'<br />Go</p>
<p>sp_configure 'allow updates', 0 reconfigure with override<br />Go</p>
<p>sp_dboption '置疑的数据库名', 'single user', 'false'<br />Go</p>
<p>方法二</p>
<p>事情的起因<br />昨天，系统管理员告诉我，我们一个内部应用数据库所在的磁盘空间不足了。我注意到数据库事件日志文件XXX_Data.ldf文件已经增长到了3GB，于是我决意缩小这个日志文件。经过收缩数据库等操作未果后，我犯了一个自进入行业以来的最大最愚蠢的错误：竟然误删除了这个日志文件！后来我看到所有论及数据库恢复的文章上都说道：“无论如何都要保证数据库日志文件存在，它至关重要”，甚至微软甚至有一篇KB文章讲如何只靠日志文件恢复数据库的。我真是不知道我那时候是怎么想的？！</p>
<p>这下子坏了！这个数据库连不上了，企业管理器在它的旁边写着“(置疑)”。而且最要命的，这个数据库从来没有备份了。我唯一找得到的是迁移半年前的另外一个数据库服务器，应用倒是能用了，但是少了许多记录、表和存储过程。真希望这只是一场噩梦！</p>
<p>没有效果的恢复步骤<br />附加数据库<br />_Rambo讲过被删除日志文件中不存在活动日志时，可以这么做来恢复：</p>
<p>1，分离被置疑的数据库，可以使用sp_detach_db<br />2，附加数据库，可以使用sp_attach_single_file_db</p>
<p>但是，很遗憾，执行之后，SQL Server质疑数据文件和日志文件不符，所以无法附加数据库数据文件。</p>
<p>DTS数据导出<br />不行，无法读取XXX数据库，DTS Wizard报告说“初始化上下文发生错误”。</p>
<p>紧急模式<br />怡红公子讲过没有日志用于恢复时，可以这么做：</p>
<p>1，把数据库设置为emergency mode</p>
<p>2，重新建立一个log文件</p>
<p>3，把SQL Server 重新启动一下</p>
<p>4，把应用数据库设置成单用户模式</p>
<p>5，做DBCC CHECKDB</p>
<p>6，如果没有什么大问题就可以把数据库状态改回去了，记得别忘了把系统表的修改选项关掉</p>
<p> </p>
<p>我实践了一下，把应用数据库的数据文件移走，重新建立一个同名的数据库XXX，然后停掉SQL服务，把原来的数据文件再覆盖回来。之后，按照怡红公子的步骤走。</p>
<p>但是，也很遗憾，除了第2步之外，其他步骤执行非常成功。可惜，重启SQL Server之后，这个应用数据库仍然是置疑！</p>
<p>不过，让我欣慰的是，这么做之后，倒是能够Select数据了，让我大出一口气。只不过，组件使用数据库时，报告说：“发生错误：-2147467259,未能在数据库 'XXX' 中运行 BEGIN TRANSACTION，因为该数据库处于回避恢复模式。”</p>
<p> </p>
<p>最终成功恢复的全部步骤<br />设置数据库为紧急模式<br />        停掉SQL Server服务；</p>
<p>       把应用数据库的数据文件XXX_Data.mdf移走；</p>
<p>      重新建立一个同名的数据库XXX；</p>
<p>       停掉SQL服务；</p>
<p>      把原来的数据文件再覆盖回来；</p>
<p>     运行以下语句，把该数据库设置为紧急模式；</p>
<p>    运行“Use Master</p>
<p>Go</p>
<p>sp_configure 'allow updates', 1</p>
<p>reconfigure with override</p>
<p>Go”</p>
<p>执行结果：</p>
<p>DBCC 执行完毕。如果 DBCC 输出了错误信息，请与系统管理员联系。</p>
<p>已将配置选项 'allow updates' 从 0 改为 1。请运行 RECONFIGURE 语句以安装。</p>
<p> </p>
<p>接着运行“update sysdatabases set status = 32768 where name = 'XXX'”</p>
<p>执行结果：</p>
<p>（所影响的行数为 1 行）</p>
<p> </p>
<p>      重启SQL Server服务；</p>
<p>     运行以下语句，把应用数据库设置为Single User模式；</p>
<p>      运行“sp_dboption 'XXX', 'single user', 'true'”</p>
<p>执行结果：</p>
<p>      命令已成功完成。</p>
<p> </p>
<p>ü         做DBCC CHECKDB；</p>
<p>      运行“DBCC CHECKDB('XXX')”</p>
<p>执行结果：</p>
<p>'XXX' 的 DBCC 结果。</p>
<p>'sysobjects' 的 DBCC 结果。</p>
<p>对象 'sysobjects' 有 273 行，这些行位于 5 页中。</p>
<p>'sysindexes' 的 DBCC 结果。</p>
<p>对象 'sysindexes' 有 202 行，这些行位于 7 页中。</p>
<p>'syscolumns' 的 DBCC 结果。</p>
<p>………</p>
<p> </p>
<p>ü         运行以下语句把系统表的修改选项关掉；</p>
<p>      运行“sp_resetstatus "XXX"</p>
<p>go</p>
<p>sp_configure 'allow updates', 0</p>
<p>reconfigure with override</p>
<p>Go”</p>
<p>执行结果：</p>
<p>在 sysdatabases 中更新数据库 'XXX' 的条目之前，模式 = 0，状态 = 28（状态 suspect_bit = 0），</p>
<p>没有更新 sysdatabases 中的任何行，因为已正确地重置了模式和状态。没有错误，未进行任何更改。</p>
<p>DBCC 执行完毕。如果 DBCC 输出了错误信息，请与系统管理员联系。</p>
<p>已将配置选项 'allow updates' 从 1 改为 0。请运行 RECONFIGURE 语句以安装。</p>
<p> </p>
<p>    重新建立另外一个数据库XXX.Lost；</p>
<p>DTS导出向导<br />     运行DTS导出向导；</p>
<p>     复制源选择EmergencyMode的数据库XXX，导入到XXX.Lost；</p>
<p>        选择“在SQL Server数据库之间复制对象和数据”，试了多次，好像不行，只是复制过来了所有表结构，但是没有数据，也没有视图和存储过程，而且DTS向导最后报告复制失败；</p>
<p>       所以最后选择“从源数据库复制表和视图”，但是后来发现，这样总是只能复制一部分表记录；</p>
<p>      于是选择“用一条查询指定要传输的数据”，缺哪个表记录，就导哪个；</p>
<p>        视图和存储过程是执行SQL语句添加的。</p>
<p> </p>
<p>维护Sql Server中表的索引<br />在使用和创建数据库索引中经常会碰到一些问题，在这里可以采用一些另类的方法解决…</p>
<p>--第一步：查看是否需要维护，查看扫描密度/Scan Density是否为100%<br />declare @table_id int<br />set @table_id=object_id('表名')<br />dbcc showcontig(@table_id)</p>
<p>--第二步:重构表索引<br />dbcc dbreindex('表名',pk_索引名,100)</p>
<p>--重做第一步，如发现扫描密度/Scan Density还是小于100%则重构表的所有索引<br />--杨铮：并不一定能达100%。<br />dbcc dbreindex('表名','',100)</p>
<p>SQL Server补丁安装常见问题<br />谁碰到问题就看看咯：）</p>
<p>一、补丁安装过程中常见问题</p>
<p>如果在安装补丁的时候遇到如下类似错误：</p>
<p>1、安装过程中出现“以前进行的程序创建了挂起的文件操作，运行安装程序前，必须重新启动”，请按照下面步骤解决：</p>
<p>a、重启机器，再进行安装，如果发现还有该错误，请按下面步骤 <br />b、在开始-&gt;运行中输入regedit <br />c、到HKEY_LOCAL_MACHINE YSTEM\CurrentControlSet\Control ession Manager 位置 <br />d、选择文件-&gt;倒出,保存 <br />e、在右边窗口右击PendingFileRenameOperations，选择删除，然后确认 <br />f、重启安装，问题解决</p>
<p>如果还有同样问题，请检查其它注册表中是否有该值存在，如有请删掉。</p>
<p>2、在安装SQL Server SP3，有时候会出现：无论用windows认证还是混和认证，都出现密码错误的情况，这时查看临时目录下的sqlsp.out，会发现以下描述： <br />[TCP/IP Sockets]Specified SQL server not found. <br />[TCP/IP Sockets]ConnectionOpen (Connect()). <br />其实这是SQL Server SP3的一个小bug，在安装sp3的时候，没有监听tcp/ip端口，可以按照以下步骤进行：</p>
<p>1、打开SQL server客户器网络实用工具和服务器网络工具，确保启用的协议中包含name pipe，并且位置在第一位. <br />2、确保[HKEY_LOCAL_MACHINE OFTWARE\Microsoft\MSSQLServer\Client\ConnectTo] <br />"DSQUERY"="DBNETLIB". <br />如果没有，请自己建立 <br />3、停止mssql. <br />4、进行安装.</p>
<p>这样就可以进行正确安装了。</p>
<p>二、SQL Server补丁版本的检查</p>
<p>SQL Server的补丁版本检查不如Windows 补丁版本检查直接，一个系统管理员，如果不了解SQL Server版本对应的补丁号，可能也会遇到一点麻烦，因此在这说明一下，通过这样的办法判别机器是安全的办法，不会对系统产生任何影响。 <br />1、用Isql或者SQL查询分析器登录到SQL Server，如果是用Isql，请在cmd窗口输入isql -U sa,然后输入密码，进入；如果是用SQL查询分析器，请从程序中启动，输入sa和密码（也可以用windows验证）。 <br />2、在ISQL中输入： <br />Select @@Version； <br />go</p>
<p>或者SQL查询分析器中输入(其实如果不想输入，只要打开帮助的关于就可以了:)) <br />Select @@Version； <br />然后按执行； <br />这时会返回SQL的版本信息，如下： <br />Microsoft SQL Server 2000 - 8.00.760 (Intel X86) Dec 17 2002 14:22:05 Copyright (c) 1988-2003 Microsoft Corporation Enterprise Edition on Windows NT 5.0 (Build 2195: Service Pack 3) <br />其中的8.00.760就是SQL Server的版本和补丁号。对应关系如下：</p>
<p>8.00.194 －——————SQL Server 2000 RTM <br />8.00.384 －——————(SP1) <br />8.00.534 －——————(SP2) <br />8.00.760 －——————(SP3)</p>
<p>这样我们就能看到SQL Server的正确版本和补丁号了。</p>
<p>我们也可以用xp_msver看到更详细的信息</p>
<p>Sql Server数据库的备份和恢复措施<br />最常用的操作，新手们看看……</p>
<p>一、备份数据库</p>
<p>1、打开SQL企业管理器，在控制台根目录中依次点开Microsoft SQL Server<br />2、SQL Server组--&gt;双击打开你的服务器--&gt;双击打开数据库目录<br />3、选择你的数据库名称（如论坛数据库Forum）--&gt;然后点上面菜单中的工具--&gt;选择备份数据库<br />4、备份选项选择完全备份，目的中的备份到如果原来有路径和名称则选中名称点删除，然后点添加，如果原来没有路径和名称则直接选择添加，接着指定路径和文件名，指定后点确定返回备份窗口，接着点确定进行备份</p>
<p>二、还原数据库</p>
<p>1、打开SQL企业管理器，在控制台根目录中依次点开Microsoft SQL Server<br />2、SQL Server组--&gt;双击打开你的服务器--&gt;点图标栏的新建数据库图标，新建数据库的名字自行取<br />3、点击新建好的数据库名称（如论坛数据库Forum）--&gt;然后点上面菜单中的工具--&gt;选择恢复数据库<br />4、在弹出来的窗口中的还原选项中选择从设备--&gt;点选择设备--&gt;点添加--&gt;然后选择你的备份文件名--&gt;添加后点确定返回，这时候设备栏应该出现您刚才选择的数据库备份文件名，备份号默认为1（如果您对同一个文件做过多次备份，可以点击备份号旁边的查看内容，在复选框中选择最新的一次备份后点确定）--&gt;然后点击上方常规旁边的选项按钮<br />5、在出现的窗口中选择在现有数据库上强制还原，以及在恢复完成状态中选择使数据库可以继续运行但无法还原其它事务日志的选项。在窗口的中间部位的将数据库文件还原为这里要按照你SQL的安装进行设置（也可以指定自己的目录），逻辑文件名不需要改动，移至物理文件名要根据你所恢复的机器情况做改动，如您的SQL数据库装在D:\Program Files\Microsoft SQL Server\MSSQL\Data，那么就按照您恢复机器的目录进行相关改动改动，并且最后的文件名最好改成您当前的数据库名（如原来是bbs_data.mdf，现在的数据库是forum，就改成forum_data.mdf），日志和数据文件都要按照这样的方式做相关的改动（日志的文件名是*_log.ldf结尾的），这里的恢复目录您可以自由设置，前提是该目录必须存在（如您可以指定d: qldata\bbs_data.mdf或者d: qldata\bbs_log.ldf），否则恢复将报错<br />6、修改完成后，点击下面的确定进行恢复，这时会出现一个进度条，提示恢复的进度，恢复完成后系统会自动提示成功，如中间提示报错，请记录下相关的错误内容并询问对SQL操作比较熟悉的人员，一般的错误无非是目录错误或者文件名重复或者文件名错误或者空间不够或者数据库正在使用中的错误，数据库正在使用的错误您可以尝试关闭所有关于SQL窗口然后重新打开进行恢复操作，如果还提示正在使用的错误可以将SQL服务停止然后重起看看，至于上述其它的错误一般都能按照错误内容做相应改动后即可恢复</p>
<p>三、收缩数据库</p>
<p>一般情况下，SQL数据库的收缩并不能很大程度上减小数据库大小，其主要作用是收缩日志大小，应当定期进行此操作以免数据库日志过大<br />1、设置数据库模式为简单模式：打开SQL企业管理器，在控制台根目录中依次点开Microsoft SQL Server--&gt;SQL Server组--&gt;双击打开你的服务器--&gt;双击打开数据库目录--&gt;选择你的数据库名称（如论坛数据库Forum）--&gt;然后点击右键选择属性--&gt;选择选项--&gt;在故障还原的模式中选择“简单”，然后按确定保存<br />2、在当前数据库上点右键，看所有任务中的收缩数据库，一般里面的默认设置不用调整，直接点确定<br />3、收缩数据库完成后，建议将您的数据库属性重新设置为标准模式，操作方法同第一点，因为日志在一些异常情况下往往是恢复数据库的重要依据</p>
<p>四、设定每日自动备份数据库</p>
<p>强烈建议有条件的用户进行此操作！<br />1、打开企业管理器，在控制台根目录中依次点开Microsoft SQL Server--&gt;SQL Server组--&gt;双击打开你的服务器<br />2、然后点上面菜单中的工具--&gt;选择数据库维护计划器<br />3、下一步选择要进行自动备份的数据--&gt;下一步更新数据优化信息，这里一般不用做选择--&gt;下一步检查数据完整性，也一般不选择<br />4、下一步指定数据库维护计划，默认的是1周备份一次，点击更改选择每天备份后点确定<br />5、下一步指定备份的磁盘目录，选择指定目录，如您可以在D盘新建一个目录如：d:\databak，然后在这里选择使用此目录，如果您的数据库比较多最好选择为每个数据库建立子目录，然后选择删除早于多少天前的备份，一般设定4－7天，这看您的具体备份要求，备份文件扩展名一般都是bak就用默认的<br />6、下一步指定事务日志备份计划，看您的需要做选择--&gt;下一步要生成的报表，一般不做选择--&gt;下一步维护计划历史记录，最好用默认的选项--&gt;下一步完成<br />7、完成后系统很可能会提示Sql Server Agent服务未启动，先点确定完成计划设定，然后找到桌面最右边状态栏中的SQL绿色图标，双击点开，在服务中选择Sql Server Agent，然后点击运行箭头，选上下方的当启动OS时自动启动服务<br />8、这个时候数据库计划已经成功的运行了，他将按照您上面的设置进行自动备份</p>
<p>修改计划：<br />1、打开企业管理器，在控制台根目录中依次点开Microsoft SQL Server--&gt;SQL Server组--&gt;双击打开你的服务器--&gt;管理--&gt;数据库维护计划--&gt;打开后可看到你设定的计划，可以进行修改或者删除操作</p>
<p>五、数据的转移（新建数据库或转移服务器）</p>
<p>一般情况下，最好使用备份和还原操作来进行转移数据，在特殊情况下，可以用导入导出的方式进行转移，这里介绍的就是导入导出方式，导入导出方式转移数据一个作用就是可以在收缩数据库无效的情况下用来减小（收缩）数据库的大小，本操作默认为您对SQL的操作有一定的了解，如果对其中的部分操作不理解，可以咨询动网相关人员或者查询网上资料<br />1、将原数据库的所有表、存储过程导出成一个SQL文件，导出的时候注意在选项中选择编写索引脚本和编写主键、外键、默认值和检查约束脚本选项<br />2、新建数据库，对新建数据库执行第一步中所建立的SQL文件<br />3、用SQL的导入导出方式，对新数据库导入原数据库中的所有表内容</p>
<p>利用数据库日志恢复数据到时间点的操作<br />由于不正常的数据丢失，而又不想使用备份数据还原，只要原来有备份且当前日志保存完好，可以采用这个方法试试，说不定可挽回损失……</p>
<p>1，如果误操作之前存在一个全库备份（或已有多个差异备份或增量备份），首先要做的事就是进<br />进行一次日志备份（如果为了不让日志文件变大而置trunc. log on chkpt.选项为1那你就死翘了）<br />    backup log dbName to disk='fileName'<br />2，恢复一个全库备份，注意需要使用with norecovery，如果还有其他差异或增量备份，则逐个恢<br />复<br />    restore database dbName from disk='fileName' with norecovery<br />3，恢复最后一个日志备份即刚做的日志备份，指定恢复时间点到误操作之前的时刻<br />    restore log dbName from disk='fileName'<br />    with stopat='date_time'</p>
<p>以上这些操作都可以在SQL SERVER企业管理器里完成，难度不大。。。</p>
<p>当然，如果误操作是一些不记日志的操作比如truncate table，select into等操作，那么是无法利<br />用上述方法来恢复数据的...</p>
<p>SQL Server2000数据库文件损坏时如何恢复<br />出现这样的问题是比较严重的了，能否修复只能看你的运气……</p>
<p>SQL Server2000中，如果数据库文件（非系统数据库文件）遇到错误的时候，仅适用于非master,msdb的数据库。</p>
<p>说明如下：</p>
<p>1 建一个测试数据库test(数据库类型为完全)<br />2 建一个表，插入点记录<br />  create table a(c1 varchar(2))<br />  go<br />  insert into a values('aa')<br />  go<br />  insert into a values('bb')<br />  go<br />3 作完全备份，到文件test_1.bak<br />4 在作一点修改<br />  insert into a values('cc')<br />  go<br />  create table b(c1 int)<br />  go<br />  insert into b values(1)<br />  go<br />  insert into b values(2)<br />  go<br />5 shutdown 数据库服务器<br />6 用ultraedit编辑数据库文件test_data.mdf,随便修改点字节内容,相当于数据库遭到致命的损坏。<br />7 启动数据库，并且运行企业管理器，点开数据库，看到test变成灰色，而且显示置疑。<br />8 运行isql -SLocalhost -Usa -P<br />1&gt; backup log test TO DISK='D:Program FilesMicrosoft SQL ServerMSSQLBACKUP <br />est_2.bak' WITH NO_TRUNCATE<br />2&gt;go<br />已处理 2 页，这些页属于数据库 'test' 的文件 'TEST_Log'（位于文件 1 上）。<br />BACKUP LOG 操作成功地处理了 2 页，花费了 0.111 秒（0.087 MB/秒）。</p>
<p>9 进行恢复最老的完全备份<br />1&gt; RESTORE DATABASE test FROM DISK='D:Program FilesMicrosoft SQL ServerMSSQL<br />BACKUP est_1.bak' WITH NORECOVERY<br />2&gt; go<br />已处理 96 页，这些页属于数据库 'test' 的文件 'TEST_Data'（位于文件 1 上）。<br />已处理 1 页，这些页属于数据库 'test' 的文件 'TEST_Log'（位于文件 1 上）。<br />RESTORE DATABASE 操作成功地处理了 97 页，花费了 0.107 秒（7.368 MB/秒）。</p>
<p>10 恢复最近的日志<br />1&gt; RESTORE LOG test FROM DISK='D:Program FilesMicrosoft SQL ServerMSSQLBACKU<br />P est_2.bak' WITH RECOVERY<br />2&gt; go<br />已处理 2 页，这些页属于数据库 'test' 的文件 'TEST_Log'（位于文件 1 上）。<br />RESTORE LOG 操作成功地处理了 2 页，花费了 0.056 秒（0.173 MB/秒）。</p>
<p> </p>
<p>存储过程编写经验和优化措施<br />经验之谈，看看……</p>
<p>一、适合读者对象：数据库开发程序员，数据库的数据量很多，涉及到对SP（存储过程）的优化的项目开发人员，对数据库有浓厚兴趣的人。 　</p>
<p>　　二、介绍：在数据库的开发过程中，经常会遇到复杂的业务逻辑和对数据库的操作，这个时候就会用SP来封装数据库操作。如果项目的SP较多，书写又没有一定的规范，将会影响以后的系统维护困难和大SP逻辑的难以理解，另外如果数据库的数据量大或者项目对SP的性能要求很，就会遇到优化的问题，否则速度有可能很慢，经过亲身经验，一个经过优化过的SP要比一个性能差的SP的效率甚至高几百倍。 　</p>
<p>　　三、内容： 　</p>
<p>　　1、开发人员如果用到其他库的Table或View，务必在当前库中建立View来实现跨库操作，最好不要直接使用“databse.dbo.table_name”，因为sp_depends不能显示出该SP所使用的跨库table或view，不方便校验。　　</p>
<p>　　2、开发人员在提交SP前，必须已经使用set showplan on分析过查询计划，做过自身的查询优化检查。 　</p>
<p>　　3、高程序运行效率，优化应用程序，在SP编写过程中应该注意以下几点： 　　</p>
<p>　　a)SQL的使用规范：</p>
<p>　　　i.　尽量避免大事务操作，慎用holdlock子句，提高系统并发能力。</p>
<p>　　　ii.　尽量避免反复访问同一张或几张表，尤其是数据量较大的表，可以考虑先根据条件提取数据到临时表中，然后再做连接。</p>
<p>　　　iii.　尽量避免使用游标，因为游标的效率较差，如果游标操作的数据超过1万行，那么就应该改写；如果使用了游标，就要尽量避免在游标循环中再进行表连接的操作。</p>
<p>　　　iv.　注意where字句写法，必须考虑语句顺序，应该根据索引顺序、范围大小来确定条件子句的前后顺序，尽可能的让字段顺序与索引顺序相一致，范围从大到小。</p>
<p>　　　v.　不要在where子句中的“=”左边进行函数、算术运算或其他表达式运算，否则系统将可能无法正确使用索引。</p>
<p>　　　vi.　尽量使用exists代替select count(1)来判断是否存在记录，count函数只有在统计表中所有行数时使用，而且count(1)比count(*)更有效率。</p>
<p>　　　vii.　尽量使用“&gt;=”，不要使用“&gt;”。</p>
<p>　　　viii.　注意一些or子句和union子句之间的替换</p>
<p>　　　ix.　注意表之间连接的数据类型，避免不同类型数据之间的连接。</p>
<p>　　　x.　注意存储过程中参数和数据类型的关系。</p>
<p>　　　xi.　注意insert、update操作的数据量，防止与其他应用冲突。如果数据量超过200个数据页面（400k），那么系统将会进行锁升级，页级锁会升级成表级锁。 　　</p>
<p>　　b)索引的使用规范：</p>
<p>　　　i.　索引的创建要与应用结合考虑，建议大的OLTP表不要超过6个索引。</p>
<p>　　　ii.　尽可能的使用索引字段作为查询条件，尤其是聚簇索引，必要时可以通过index index_name来强制指定索引</p>
<p>　　　iii.　避免对大表查询时进行table scan，必要时考虑新建索引。</p>
<p>　　　iv.　在使用索引字段作为条件时，如果该索引是联合索引，那么必须使用到该索引中的第一个字段作为条件时才能保证系统使用该索引，否则该索引将不会被使用。</p>
<p>　　　v.　要注意索引的维护，周期性重建索引，重新编译存储过程。　　</p>
<p>　　c)tempdb的使用规范：</p>
<p>　　　i.　尽量避免使用distinct、order by、group by、having、join、cumpute，因为这些语句会加重tempdb的负担。</p>
<p>　　　ii.　避免频繁创建和删除临时表，减少系统表资源的消耗。</p>
<p>　　　iii.　在新建临时表时，如果一次性插入数据量很大，那么可以使用select into代替create table，避免log，提高速度；如果数据量不大，为了缓和系统表的资源，建议先create table，然后insert。</p>
<p>　　　iv.　如果临时表的数据量较大，需要建立索引，那么应该将创建临时表和建立索引的过程放在单独一个子存储过程中，这样才能保证系统能够很好的使用到该临时表的索引。</p>
<p>　　　 v.　如果使用到了临时表，在存储过程的最后务必将所有的临时表显式删除，先truncate table，然后drop table，这样可以避免系统表的较长时间锁定。</p>
<p>　　　 vi.　慎用大的临时表与其他大表的连接查询和修改，减低系统表负担，因为这种操作会在一条语句中多次使用tempdb的系统表。　　</p>
<p>　　d)合理的算法使用： 　　</p>
<p>　　根据上面已提到的SQL优化技术和ASE Tuning手册中的SQL优化内容,结合实际应用,采用多种算法进行比较,以获得消耗资源最少、效率最高的方法。具体可用ASE调优命令：set statistics io on, set statistics time on , set showplan on 等</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 00:57:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/%e9%80%89%e6%8b%a9/" title="选择">选择</a>, <a href="https://www.iamivan.net/tag/%e5%a4%87%e4%bb%bd/" title="备份">备份</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>SQL SERVER实用经验技巧集的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zO8X3b.html" rel="bookmark">SQL SERVER实用经验技巧集     选择自 longrujun 的 Blog</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|技巧  Sql Server实用操作小技巧集合包括安装时提示有挂起的操作.收缩数据库.压缩数据库.转移数据库给新用户以已存在用户权限.检查备份集.修复数据库等  (一)挂起操作在安装Sql或sp补丁的时候系统提示之前有挂起的安装操作,要求重启,这里往往重启无用,解决办法:到HKEY_LOCAL_MACHINE YSTEM\CurrentControlSet\Control ession Manager删除PendingFileRenameOperations (二)收缩数据库--重			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqj6ep.html" rel="bookmark">SQL SERVER实用经验技巧集 &lbrack;一&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|技巧 此文是Sql Server实用操作小技巧集合,包括安装时提示有挂起的操作.收缩数据库.压缩数据库.转移数据库给新用户以已存在用户权限.检查备份集.修复数据库等.草地chin ai tp owerftGjY (一)挂起操作草地chin ai tp owerftGjY 在安装Sql或sp补丁的时候系统提示之前有挂起的安装操作,要求重启,这里往往重启无用,解决办法: 到HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Sessi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQo7Qp.html" rel="bookmark">SQL SERVER实用经验技巧集 &lbrack;三&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|技巧 维护Sql Server中表的索引 在使用和创建数据库索引中经常会碰到一些问题,在这里可以采用一些另类的方法解决-ww w.iTbulo.coGJJWE --第一步:查看是否需要维护,查看扫描密度/Scan Density是否为100% declare @table_id int set @table_id=object_id('表名') dbcc showcontig(@table_id)ww w.iTbulo.coGJJWE --第二步:重构表索引 dbcc dbrein			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MW4n7p.html" rel="bookmark">SQL SERVER实用经验技巧集 &lbrack;二&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|技巧 删除数据库中重复数据的几个方法 数据库的使用过程中由于程序方面的问题有时候会碰到重复数据,重复数据导致了数据库部分设置不能正确设置-- iTbulo . c omOZh1q 方法一iTbulo . c omOZh1q declare @max integer,@id integer declare cur_rows cursor local for select 主字段,count(*) from 表名 group by 主字段 having count(*) &gt; 1 ope			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apXAYLz.html" rel="bookmark">Oracle经验技巧集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				oracle|技巧  Oracle经验技巧集1．删除表空间    DROP TABLESPACE TableSpaceName [INCLUDING CONTENTS [AND DATAFILES]]2．删除用户    DROP USER User_Name CASCADE3．删除表的注意事项    在删除一个表中的全部数据时,须使用TRUNCATE TABLE 表名;因为用DROP TABLE,DELETE * FROM 表名时,TABLESPACE表空间该表的占用空间并未释放,反复几次DRO			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z78944b.html" rel="bookmark">Illustrator中图形逻辑本质与实用经验技巧分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				给各位Illustrator软件的使用者们来详细的分享一下图形逻辑本质与实用经验技巧. 教程分享:                 好了,以上的信息就是小编给各位Illustrator的这一款软件的使用者们带来的详细的图形逻辑本质与实用经验技巧分享的全部内容了,各位看到这里的使用者们,小编相信大家现在是非常的清楚了吧,希望小编上面的教程能给各位带去有用的帮助.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qzDvvvM.html" rel="bookmark">Sql Server实用操作小技巧集合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|集合|技巧 包括安装时提示有挂起的操作.收缩数据库.压缩数据库.转移数据库给新用户以已存在用户权限.检查备份集.修复数据库等  (一)挂起操作在安装Sql或sp补丁的时候系统提示之前有挂起的安装操作,要求重启,这里往往重启无用,解决办法:到HKEY_LOCAL_MACHINE YSTEM\CurrentControlSet\Control ession Manager删除PendingFileRenameOperations(二)收缩数据库--重建索引DBCC REINDEXDBC			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjZx6b.html" rel="bookmark">JBuilder9&plus;SQL SERVER 2000数据库连接技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|技巧|数据|数据库|数据库连接 最近公司准备做一个小项目,DB用SQL SERVER 2000,开发平台为Java2,开发工具使用JBuilder9,所以我仔细分析了一下在此情况下的数据库连接方法.其实大家都知道,Java与DB的连接主要分为四种类型: (1)Type1:使用JDBC-ODBC桥实现DB连接,此方法适合于在WINDOWS平台上使用,缺点是不能在APPLET上使用,如果要在客户端实现DB通信,那么必须设置ODBC数据源. (2)Type2:作用Native-API桥实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDwmkXp.html" rel="bookmark">Illustrator一些实用经验技巧分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				给各位Illustrator软件的使用者们来详细的分享一下实用的经验技巧. 分享一览:               好了,以上的信息就是小编给各位Illustrator的这一款软件的使用者们带来的详细的实用的经验技巧解析分享的全部内容了,各位看到这里的使用者们,小编相信大家现在是非常的清楚了吧,希望小编上面的教程能给大家带去有用的帮助.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYm7ZM.html" rel="bookmark" class="title">Flash MX 2004实例制作视频教程：情人节贺卡&lpar;1&rpar;</a>
					<div>
						教程|视频教程 第 76 节:情人节贺卡(1) 课程目标:制作&lt;情人节贺卡&gt;贺卡 课程要点:使用Flash MX 2004制作&lt;情人节贺卡&gt;贺卡.实例教程共四节,这是第一节.同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boA0Vp.html" rel="bookmark" class="title">Fireworks轻松绘制简单卡通海景画</a>
					<div>
						本教程主要通过Fireworks绘制一幅卡通海景画的过程来教大家如何运用基本的工具来表现清新的画面效果. 学习要点:Fireworks钢笔工具中ALT键的运用.纹理运用.减淡工具.橡皮工具 1.新建3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxxNWb.html" rel="bookmark" class="title">WPF and Silverlight学习笔记（七）</a>
					<div>
						WPF and Silverlight学习笔记(七):WPF布局管理之StackPanel.WrapPanel.DockPanel 一.StackPanel StackPanel是以堆叠的方式显示其中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRQKqz.html" rel="bookmark" class="title">Informix动态服务器onstat选项</a>
					<div>
						Onstat-D INFORMIX-OnLineVersion7.22.UC1--On-Line--Up00:00:38--423064Kbytes Dbspaces addressnumberfla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPBaOz.html" rel="bookmark" class="title">Juniper防火墙通过Web界面查看License授权</a>
					<div>
						进入Web界面,在Configuration &gt; Update &gt; ScreenOS/Keys中可以看到当前设备的License.显示如下: 通过命令行界面查看License 在命令行界面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M912A4M.html" rel="bookmark" class="title">Word2007中插入模式的启用与禁用</a>
					<div>
						以允许用户使用Insert键控制改写模式.当&quot;插入模式&quot;启用时,用户可以使用Insert键切换插入或改写状态.如果处于改写状态,则用户可以将光标所在处的文本直接改写为其他文本. 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7eOlb.html" rel="bookmark" class="title">怎么逆序打印Word文档</a>
					<div>
						  怎么逆序打印Word文档            1.启动Word 2013并打开文档,单击&quot;文件&quot;标签,在打开的窗口左侧选择&quot;选项&quot;选项,如图1所示. 图1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7aAXM.html" rel="bookmark" class="title">SAI和PS制作转手绘效果教程</a>
					<div>
						  最终效果图: 原图. 首先,调整图像大小. 然后复制一个图层 开始在这个图层上进行一系列操作. 调色 分类: PS入门教程 转手绘教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRdBBp.html" rel="bookmark" class="title">网页想要性感来点透明效果试试</a>
					<div>
						  随着CSS的广泛应用,透明元素在网页设计中大量采用. 通过添加透明效果,可以增添页面的对照感和可读性,同时对整体的效果妨碍又不大,可谓一举两得. 一般来说,采用透明效果显示区块.展现数据,透明效果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7ol3b.html" rel="bookmark" class="title">8孔供电独立显卡安装方法</a>
					<div>
						  1. 将显卡插到显卡插槽上,并固定好显卡螺丝.找到显卡尾端上方的显卡供电接口,(这款显卡的供电接口是两个8孔的). 2. 找到机箱里面预先留出的显卡供电插头(外面盒子里面的不用,那个是备用的),机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjODQb.html" rel="bookmark" class="title">OS X Mavericks 10&period;9 安装 U 盘制作教程</a>
					<div>
						  OS X Mavericks 10.9 DP1 已经发布,如果你需要制作安装 U 盘,可以参考以下教程: 首先你需要开启显示隐藏文件的功能.在「终端」(Terminal)应用中执行下面的命令即可: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7EBjM.html" rel="bookmark" class="title">eclipse抛出异常问题</a>
					<div>
						问题描述 java.lang.NullPointerExceptionatpkg.MyGameCanvas.&lt;init&gt;(+8661)atpkg.TestGameMIDlet.&lt;in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NAdmz.html" rel="bookmark" class="title">SEOER该怎么去做优化百度</a>
					<div>
						而面对百度目前的这种状况要如何应对呢,这个除了不断的坚持以外还需要改变方法,从百度的算法更新当中知道,百度对我们的网站要求更加高了,所以首先还得从网站的自身出发.相信任何时候网站的服务器的稳定状况都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NN9WM.html" rel="bookmark" class="title">关于二进制存储图片和读取图片的问题</a>
					<div>
						问题描述 关于二进制存储图片和读取图片的问题 如何将图片以二进制的形式存入数据库中 在二进制的形式读取出来 求代码 解决方案 以二进制进行存储和读取图片以二进制进行存储和读取图片.NET中二进制图片的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAO8YM.html" rel="bookmark" class="title">YII MVC View中的&dollar;this</a>
					<div>
						WebsiteController Java代码   &lt;?php   class WebsiteController extends CController   {       function ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr9BZM.html" rel="bookmark" class="title">分布式系统设计，在BS架构中的应用</a>
					<div>
						问题描述 分布式系统设计,在BS架构中的应用 分布式系统设计,请有经验的朋友提供方案.分布式系统设计,请有经验的朋友提供方案.分布式系统设计,请有经验的朋友提供方案.分布式系统设计,请有经验的朋友提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7Qm4p.html" rel="bookmark" class="title">在 android 中的文件中输入数据</a>
					<div>
						问题描述 在 android 中的文件中输入数据 下面的代码重写了文件.我想让原来的数据还保持一致. osw..append (data); 但是没有获得结果. public void WriteSe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRGVgz.html" rel="bookmark" class="title">Qt之字体文件（TTF）</a>
					<div>
						简述 TTF(TrueTypeFont)是Apple公司和Microsoft公司共同推出的字体文件格式,随着windows的流行,已经变成最常用的一种字体文件表示方式. 在一些特殊的场合,系统字符集不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD8Bez.html" rel="bookmark" class="title">&lbrack;css&rsqb;31中选择器的应用</a>
					<div>
						目录[-] 1. * 2. #X 3. .X 4. X Y 5. X 6. X:visited and X:link 7. X + Y 8. X &gt; Y 9. X ~ Y 10. X[title ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boK876b.html" rel="bookmark" class="title">排序算法-如何将多个文件&lpar;每个文件大于1G&rpar;字符串进行行为单位排序，并且排序时内存小于50M&period;</a>
					<div>
						问题描述 如何将多个文件(每个文件大于1G)字符串进行行为单位排序,并且排序时内存小于50M. 现有N个文件(N&gt;5): ? 每个文件包含了多行的字符串 ? 每个文件大小大于1G ? 文件内字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDjVBz.html" rel="bookmark" class="title">剖析各类恶意网页对策分析&mdash;注册表使用全攻略之七&lowbar;注册表</a>
					<div>
						剖析各类恶意网页对策分析-注册表使用全攻略之七 互联网利用IE等的漏洞完全可以让你通过浏览网页让你的电脑面目全非,或者格盘,甚至中下木马,传播病毒,而且这种形式的传播愈演愈烈,闲话少说了,现在来分析一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgEWkM.html" rel="bookmark" class="title">百度api-百度API怎么在聚合后还会显示信息窗口</a>
					<div>
						问题描述 百度API怎么在聚合后还会显示信息窗口 如题,我在百度地图上用 markers.push(new BMap.Marker(pt)); var markerClusterer = new BM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkGlKM.html" rel="bookmark" class="title">asp&comma;VBscript语法错误&comma;史上最全最详细最精确第1&sol;3页&lowbar;ASP基础</a>
					<div>
						ASP错误总结  -------------------------------------------------------------------------------- Microsoft  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7xoEM.html" rel="bookmark" class="title">jQuery的运行机制和设计理念分析&lowbar;jquery</a>
					<div>
						其短小精悍,使用简单方便,性能高效,能极大地提高开发效率,是开发Web应用的最佳的辅助工具之一.因此大部分开发者在抛弃Prototype而选择jQuery来进行Web开发. 一些开发人员在使用jQue ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkrAAM.html" rel="bookmark" class="title">Can t connect to MySQL server 常见问题解决办法</a>
					<div>
						连接数据库教程的时候显示Can't connect to MySQL server (10060),基本可以按照以下思路进行排查: 1. 网络不通.     检查能不能ping通. 2. 防火墙设置. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKy9WM.html" rel="bookmark" class="title">手机QQ在哪关注天天爱游戏  手机QQ关注天天爱游戏方法</a>
					<div>
						1.在手机中点击QQ登录之后我们找到[动态]打开进入,如下图所示 2.然后在打开动态界面中我们找到[管理]按钮,打开进入 3.点击滑动[游戏]然后进入之后我们如图所示开启它 4.按钮变绿色表示[游戏] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrVYEp.html" rel="bookmark" class="title">asp连接mysql数据库详细实现代码&lowbar;应用技巧</a>
					<div>
						想要asp能连接mysql数据库需要安装MySQL ODBC 3.51 驱动 http://www.jb51.net/softs/19910.html我们先看下面这段代码 复制代码 代码如下: set ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYNL1b.html" rel="bookmark" class="title">UIScrollView 新手教程</a>
					<div>
						本文讲的是UIScrollView 新手教程, Ray的温馨提示:这是本站原先 Objective-C 热门教程的 Swift 升级版.Corinne Krych 将教程升级到了Swift, iOS  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wWRdz.html" rel="bookmark" class="title">Java IO 概述</a>
					<div>
						原文链接作者: Jakob Jenkov   译者: 李璟(jlee381344197@gmail.com)  校对:方腾飞 在这一小节,我会试着给出Java IO(java.io)包下所有类的概述. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdGWXp.html" rel="bookmark" class="title">EMC将收购软件定义存储初创公司ScaleIO</a>
					<div>
						有消息称,EMC已经收购了存储软件初创公司ScaleIO,或者正在收购的最后阶段,此举可能有助于进一步定义EMC的软件定义存储战略,以及帮助改变企业采购存储的方式. 根据以色列http://www.a ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.051 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
